# Dialog

## 基本

Dialog 是一个对话框，本对话框的 z=80，最好直接放置在舞台上。

## 属性


- **title** : string

    标题。默认“提示”。

- **buttons** : array

    设定需要显示的按钮，默认 ['yes', 'no', 'cancel','close']

- **parts** : array

    组成部分，默认 ['title', 'content', 'bottom']。

- **titleBar** : HBox

    标题栏。

- **contentBar** : VBox

    内容区。

- **bottomBar** : VBox

    底部栏，放置几个按钮。

- **closeButton** ：Button

    关闭按钮。

- **yesButton** ：Button

    yes按钮。

- **noButton** ：Button

    no按钮。

- **cancelButton** ：Button

    cancel按钮。

## 方法

无。

## 事件

- yes

    对应构造参数中的 onYes

- no

    对应构造参数中的 onNo
    
- cancel

    对应构造参数中的 onCancel
    
- close

    对应构造参数中的 onClose
    
## 示例

```js
var dialog=new Dialog({
    title:'EXAMPLE',
    width:320,
    height:320,
    onYes:(et)=>{
        //...
    }
});

dialog.contentBar.add(new Label({
    text:'HELLO, HOW ARE YOU!',
    left:10,
    top:10,
    skin:dialog.skin.contentBarSkin.labelSkin
}));

var btn=new Button({
    text:"CLOSE",
    right:0,
    top:0,
    onClick:(et)=>{
        dialog.visible?dialog.hide():dialog.show();
    }
});

SM.add(btn);
SM.add(dialog);

GM.start();
```

效果图如下：

![](../imgs/QQ截图20191213232802.png)