# Masker

## 基本

本模块用来对 UI 元素进行遮罩。

3D 物体请采用 alphaMap 来完成。

目前，本插件按照 UI 元素的大小进行遮罩，比如用圆来遮罩，就是 UI 元素的宽高归一化为 [0,1] 之后的 0.5 作为圆半径，圆外的内容全部隐藏。

## 属性

- subType:object
  
  遮罩类型，含 type 和 数据成员，type 可以为 rect 矩形，roundrect 圆角矩形（默认），circle 圆。

  当 type 是 circle 或 roundrect，数据成员都是 radius。
  
  当 type 是 rect，数据成员是 width/height。

  所有数据是归一化 [0,1] 之后的数值。

## 方法

- void attach(uiobj:UIObject)
  
  附加到 uiobj 元素上。

## 事件

无

## 示例

```js
var uiobj=new Picture({
    url:'http://www.example.com/xxx.jpg'
});

uiobj.on('created', function(){
    var uim=new UIMask({
        subType:{
            type:'roundrect',
            radius:0.04
        }
    });
    uim.attach(uiobj);
});

SM.add(uiobj);
```