# PictureAnimator

## 基本

本类实现了精灵动画，用在 2D UI 元素上。

本类继承于 Picture。

提供给本类的图片是一个水平拼接的图片，示例图如下：

![walkingManSpriteSheet](../imgs/walkingManSpriteSheet.png)

## 属性

- **url** : string|UUID|THREE.Texture|GradientTexture
  
  精灵图片地址。默认值就是上面那个图片。

- **loop** : string

    循环播放方式，可以为 once|forever(默认)

- **frames** : int

    帧数，比如上图就是 8 帧。

- **fps** : int

    帧率，默认为 10，表示 10 帧/秒。

- **status** : string

    当前所处状态，可以为 play|pause|stop

## 方法

- **play**() : void

    播放。

- **pause**() : void

    暂停。

- **stop**() : void

    停止。

## 示例

```js
var pa=new PictureAnimator({
    url:'xxx.jpg',
    frames:10,
	centerX:0,
	centerY:0
});

SM.add(pa);
SM.layoutUI();

pa.play();
```