# UIObject

## 基本

本类是 UI 元素基类，继承于 [GObject](../core/GObject.md)。

定位方式采用 left/right/top/bottom 逻辑，不采用 x/y 方式。

再辅以 margin/padding/centerX/centerY/anchorX/anchorY 来完成更灵活的布局。

另外，整个 UI 体系是按照 Web 方式来处理的，即屏幕左上角为 (0,0)，右下角为 (窗口宽,窗口高)。

本类采用了标准的盒子模型，但没有 border 概念，宽高包含了 padding 在内，不包含 margin。

## 属性

- **width** : number|undefined
  
  宽度。如设定了 left/right，则宽度会被设置为：父亲宽-right-left。

- **height** : number|undefined
  
  高度。如设定了 top/bottom，则高度会被设置为：父亲高-top-bottom。

- **left** : number|undefined

    元素左侧距父亲左边的距离。

- **right** : number|undefined

    元素右侧距父亲右边的距离。

- **top** : number|undefined

    元素顶部距父亲顶边的距离。

- **bottom** : number|undefined

    元素底部距父亲底边的距离。

- **centerX** : number|undefined

    元素水平居中对齐。若设定了 left/right 则居中失效。

- **centerY** : number|undefined

    元素垂直居中对齐。若设定了 top/bottom 则居中失效。

- **x** : number|undefined

    元素在屏幕中的 x 像素位置。
    
    只读，默认 0。

## 方法

- **contains**(x : number,y : number) : bool
  
  坐标是否在本元素内。

- **layout**() : void

    对本元素进行布局。如果本元素是 Box 及其之类，本方法还会对所有孩子进行布局（递归）。

    如调用 `SM.layoutUI()` 则可以对整体 UI 进行一次布局，在 `GM.start()` 时，系统会自动调用一次。

## 事件

无

## 示例

无
