# Collider 碰撞器

## 基本

为 GameObject 提供碰撞能力，为了让碰撞更好的体现，GameObject 的 useBox 要设为 true。

## 属性

- **subType** : string

    子类型，可以是：

    - distance 仅距离，默认
    - direction 方向，采用了 raycaster 技术。
    - directionAndDistance 方向+距离，采用了 raycaster 技术。

- **target** : GameObject|THREE.Vector3

    目标。

- **distance** : float

    在 distance 和 directionAndDistance 模式下给定碰撞距离，默认 0.5，不能小于 0.05（小于时置为0.1）。

- **direction** : GameObject|THREE.Vector3

    对应 direction 和  directionAndDistance 模式的方向。

## 事件

- **collided**

    对应回调：onCollided 。
    
    表明已经碰撞上了。

    且抛出到 GameObject 中 onCollided 回调。

    事件参数如下：

    - target

        碰上的对象。

    - intersect

        碰撞情况。

## 命令

通过发送命令给 GameObject 来驱动本组件。

```js
gobj.command={
    type:'collid',
    subType:'direction',
    direction:new THREE.Vector3(0,0,0)
};
```

上述所有属性均可以使用。