# Mover 移动器

## 基本

为 GameObject 提供移动能力，且支持多种移动方式。

为了降低全局碰撞所消耗的大量计算（`N*N` 循环），移动器每次的移动都会上报给 SM，SM 将舞台分区（`M*N，SM.sectors`），碰撞时先看自己属于哪个区，然后寻找这个区里面的物体进行碰撞就好了，大大节省计算量。

## 属性

- **subType** : string

    子类型，可以是：

    - path 按寻路算法(A*)的路径移动
    - target 接近目标，跟踪式，默认
    - waypoint 路径点模式，在设定的路径点中走路，并规避障碍
    - patrol 巡逻，在巡逻点中随机走来走去
    - direction 只按某个方向走(无目标)

- **distance** : float

    只读，已经移动的距离。

- **pathPoints** : array

    对应 path 模式的点集。

- **wayPoints** : array

    对应 waypoint 模式的点集。

- **patrolPoints** : array

    对应 patrol 模式的点集。

- **target** : GameObject|THREE.Vector3

    对应 target 模式的目标。
    
- **direction** : GameObject|THREE.Vector3

    对应 direction 模式的方向。

## 事件

- **arrived**

    对应回调：onArrived 。
    
    表明已经到了指定地点，仅在 target/path/waypoint 模式下有效。

    且抛出到 GameObject 中 onArrived 回调。

## 命令

通过发送命令给 GameObject 来驱动本组件。

```js
gobj.command={
    type:'move',
    subType:'direction',
    direction:new THREE.Vector3(0,0,0)
};
```

上述所有属性均可以使用。



