# SceneManager

## 基本

舞台管理器（也称为场景管理器）用于管理舞台上所有物体和 UI 元素。

本管理器全局对象是 SM。

本管理器也是由游戏管理器控制的，游戏管理器获取章节后，找到章节对应的舞台，进行操作。

不同章节可以对应不同舞台，本管理器只负责当前舞台。

本管理器内置了两个 scene，一个是 3D 摄像头对应的 scene，另一个是 2D 摄像头对应的 uiScene。

SM.scene.children 和 SM.uiScene.children 是 THREE.js 部分的内容，保存的是 Object3D 对象，是一套树形结构。

而 SM.children 和 SM.uiChildren 保留的是 GObject 对象，但是一套平面结构。

当然，也提供了 SM.units 和 SM.uiUnits 来保存 SM.children 和 SM.uiChildren 对应的 Object3D 对象。

物体和 UI 元素继承于 GObject，它是 Object3D 的封装体，其成员 unit 指向 Object3D 对象。为了形成树形结构，它具有 parent/parents/children 成员。

为了让物体和 UI 元素能够统一布局，每个 GObject 有 children 成员，还有一个 childrenGroup 成员，将孩子元素的 unit 聚集在一起，当本元素移动时，孩子都会跟着走。在添加物体和 UI 元素时，其对应的 childrenGroup 也会添加到舞台上，与它同级，这样也就形成了树形结构。

故，一个是 THREE.js 树形结构模型，保存在 SM.scene 和 SM.uiScene 的 children 中，一个是每个 GObject 的 children 中。

注：物体对应的容器为 Group，UI 元素对应的容器为 Box。   

## 查找孩子

SM 提供了 getChild 函数，可以通过 key/value 来查找符合的孩子（单个），当然，你也可以通过 SM.children.find((item) => ...) 自行查找。

每个 GObject 也提供了 traverse 函数，用来遍历树形结构。


## 事件

