# GBeCool UI 布局

UI 布局是按照 HTML/CSS 逻辑来构建，而且比它还简单和强大。

将画布作为舞台，左上角 (0,0)，右下角 (画布宽,画布高)。

画布的高宽可以通过 SM.wWidth/SM.wHeight 拿到。

在游戏开始 (GM.start()) 的时候，会自动调用 SM.layoutUI() 来让所有元素进行一次布局，如果你在运行时要动态增删元素，请在合适的时候自行调用，但要注意性能问题。

在局部容器中的布局变动，可以调用容器的 layout() 来实现，在没有调用这个函数之前，对所有属性（如宽高）的赋值都不会改变布局。

left/right/top/bottom (简称 LRTB)，widht/height (简称 WH)。

## 高宽

- 没有设定高宽，则按父亲的高宽

    有些元素的宽高是例外的：

    - Label 的宽高不设置的时候是按文字的宽高来确定
    - Button 默认 120*30
    - Dialog 默认 300*200
    - PictureRoller 默认 300*200
    - VideoPlayer 默认 300*200
    - PictureAnimator 默认 128*128
    - ProgressBar 默认 100*10
    - Line 水平线高是 1，垂直线宽是 1
    - TextInput 默认高 30
    - Waitting 默认 80*80

- 如设定了 left/right，则宽度会被设置为：父亲宽-right-left
- 如设定了 top/bottom，则高度会被设置为：父亲高-top-bottom

当然，还是可以通过 LRTB 和 WH 来更改。

## 位置

元素的 x/y 是不可以设置的。

通过 LRTB 来设置元素位置。

centerX/centerY 设置元素水平或垂直居中，优先级小于 LRTB。

故，在 HBox/VBox 中是无法设置居中的（目前）。

## 偏移

anchorX/anchorY 设置元素的中心点偏移，默认为 0。

## 盒子

分为三种盒子：

- Box 定位盒子，里面的元素通过 LRTB 来布局
- HBox 水平盒子，里面的元素水平排列，放不下就换下一行
- VBox 垂直盒子，里面的元素垂直排列

要注意，舞台本身就是 Box。

HBox/VBox 有依据孩子们的宽高来拉伸自己的机制，具体依据 overflow 的设置。

- stretch：父亲的大小是所有孩子的大小总和。
- hidden：溢出直接隐藏，不可以滚动。
- scroll：溢出直接隐藏，但可以滚动。

Box 水平和垂直默认隐藏，HBox 默认水平隐藏，垂直拉伸。VBox 默认垂直隐藏，水平拉伸。

当然，也可以独立设置 overflowX/overflowY，那么影响的就是宽或高。

HBox/VBox 其实也是计算孩子的 LRTB 来实现布局，本质上与 Box 一致。

孩子中的 LRTB 是相对父亲的，以父亲的左上角为 (0,0) 点为参考点。

注意 Box 无论怎么设置，都不会拉伸。

注：盒子中有一个 scrollBox，是真正容纳元素的容器，其实所有操作都是针对它来的，这样才能实现真正的滚动。

## 层级

设置 z 的值即可，从 1-99，越大越在前。

## 外边距

采用 margin 设置外边距，可以设置为一个数，也可以设置为如下形式：

```js
{ left:0,right:0,top:0,bottom:0}
```
元素的宽高是不包含的外边距的。

## 内边距

采用 padding 设置外边距，可以设置为一个数，也可以设置为如下形式：

```js
{ left:0,right:0,top:0,bottom:0}
```
元素的宽高是包含的内边距的。

## 其他

特别注意，如果整个界面只有 2D UI，则不会抗锯齿，导致画面质量看起来很糙且透明度无效，故舞台上一定要摆放至少一个 3D 元素在界面上才行。