# GBeCool 管理器

管理器负责全局管理，所有管理器均继承自 Manager。

在 game.json 文件中可以设定每个管理器对应 js 地址。

每个 js 的格式都如下：

```js
export default class MyLGM {

    //如果有多个相同类型的管理器，则需要一个 main 作为入口函数
	main() {
        
        //我的变量
        this.myVar=1;

        //...

        //只调用一次
		GM.start();
	}

    //管理器初始化回调
	onInited() {

	}

    //帧动画回调
	onUpdated(args) {

    }
    
    //我的方法
    myMethod(arg1){

    }

}
```

注，这个管理器是什么类型的管理器是在 game.json 中指定的，代码中并没有表现。

## LogicManager