# GBeCool 页面框架

## 基本

在 2D UI 体系中，可以直接采用 Box/HBox/VBox 来完成各种布局，但如果牵涉到主页面和多个子页面逻辑，则采用 Frame + Page 逻辑就方便多了。

## Frame 框架

用来管理页面。

### 属性

- **pages** : array
  
    所有页。

- **page** : Page

    当前页。

- **pageIdx** : int

    当前页序号。

### 方法

- **add**(...pages) : void

    增加页面。

- **remove**(page) : void

    删除页面。

- **back**() : void

    返回到上一个页面。

### 示例

无。

## Page 页面

### 属性

- **title** : string

    页面标题。

- **isMain** : bool

    是否是主页面，一个 Frame 中只有一个主页面。主页面默认显示，其他页默认隐藏。

- **buttons** : array

    设定需要显示的按钮，默认 ['back', 'avatar']，可以为：['back', 'menu', 'search', 'avatar', 'more']

- **parts** : array

    组成部分，默认 ['title', 'content', 'bottom']。

- **titleBar** : HBox

    标题栏。

- **contentBar** : VBox

    内容区。

- **bottomBar** : VBox

    底部栏。

- **backButton** ：Button

    返回按钮。

- **menuButton** ：Button

    菜单按钮。

- **searchButton** ：Button

    搜索按钮。

- **avatarButton** ：Button

    头像按钮。

- **moreButton** ：Button

    更多按钮。

### 方法

无。

### 示例

无。

## 综合示例

```js
var frame=new Frame({
    onChange:function(name){
        if(name=='page'){
            console.log('页变更了');
        }
    }
});

var page=new Page({title:'主页',isMain:true,buttons:['menu', 'search', 'avatar']});
var page2=new Page({title:'关于',buttons:['back', 'more']});

page2.backButton.on('click',function(et){
    frame.page=page;
});

var cb=new Box({
    height:200
});
var btn=new Button({
    text:'转到关于页',
    centerX:0,
    centerY:0,
    onClick:function(et){
        frame.page=page2;
        //frame.back();
    }
});
cb.add(btn);

var lb=new Box({
    height:60
});
var lbl=new Label({
    text:'Copyright 2019 dotfg.com',
    centerX:0,
    centerY:0,
    skin:page.bottomBar.skin.labelSkin
});
lb.add(lbl);

page.contentBar.add(cb);
page.bottomBar.add(lb);

frame.add(page,page2);
SM.add(frame);

GM.start();
```

运行结果如下：

![](../imgs/QQ截图20191206163011.png)

![](../imgs/QQ截图20191206163040.png)



