# game.json 数据格式

### 游戏设置：

```shell
    "title": "Demo", //标题
    "desc": "",//描述
    "version": "1.0.0",//版本
    "GBeCoolVersion": "1.0.0",//GBeCool版本
    "dimension": "3D",//2D或3D
    "orientation": "vertical",//横竖屏
    "domain": "",//域名
```

### 全局数据：

```shell
    "globalData": {
        "coins": 0,
        "silvers": 0,
        "woods": 0,
        "foods": 0,
        "stones": 0,
        "crystals": 0,
        "diamonds": 0,
        "lives": 0
    },
```

### 脚本：

```shell
    "scripts": [
        {
            "uuid": "e75a70a4-78c0-cc23-7cc5-851cde712db8",//uuid
            "type": "LogicManager",//类型
            "url": "/js/myLogicManager.js"//url地址
        }
    ],
```

### 章节：

```shell
"chapters": [
        {
            "uuid": "e3b5c357-1d90-db47-dc6a-639b7e0a3249",
            "name": "myChapter",
            "text": "myChapter",
            "desc": "",
            "scene": "59C56073-3FC7-4934-BA95-B3C4BC6CB571",//舞台
            "group": "e8aa42e5-96ff-1907-83cd-78546d6fb260",//资源组
            "children": []
        }
    ],
```

### 摄像头：

```shell
"cameras": [
        {
            "uuid": "d4ed89cd-487a-de57-6909-f7bec6f677c3",
            "type": "PerspectiveCamera",
            "name": "myPerspectiveCamera",
            "far": 1000,
            "position": {
                "x": 30,
                "y": 0,
                "z": 0
            }
        }
    ],
```

### 灯光：

```shell
"lights": [
        {
            "uuid": "62e1092e-1b3b-9f6e-65f7-43c3c92b99e1",
            "type": "DirectionalLight",
            "name": "myDirectionalLight",
            "color": 16777215,
            "position": {
                "x": 10,
                "y": 10,
                "z": 10
            },
            "castShadow": true,
            "shadow": {
                "camera": {
                    "uuid": "E4606B4A-18E2-49BF-B84E-3D7FD40F76B3",
                    "type": "OrthographicCamera",
                    "left": -15,
                    "right": 15,
                    "top": 15,
                    "bottom": -15,
                    "near": 1,
                    "far": 10,
                    "width": 1024,
                    "height": 1024
                }
            },
            "target": {
                "uuid": "066C7957-ACAB-43D5-9B83-FB126FD6EF23",
                "type": "Object3D"
            }
        },
        {
            "uuid": "2c24963e-e270-4574-ca68-902a17167921",
            "type": "AmbientLight",
            "name": "myAmbientLight",
            "color": 16777215
        }
    ],
```

### 物体：

```shell
  "gameobjects": [
        {
            "uuid": "53f8c942-408c-b041-1c97-b5cfa3e03e33",
            "name": "myCube",
            "unit": "b89ecc19-1176-bc9f-fa20-0fe7004696ac",//单位
            "type": "GameObject"
        }
    ],
```

### UI：

```shell
   "uiobjects": [
        {
            "type": "Label",//类型
            "uuid": "8685d6b4-caf3-a16b-3217-21dc4e974141",//uuid
            "name": "myLabel",//名称
            "font": "17px Candara"//字体
        }
    ],
```

### 单位：

```shell
 "units": [
        {
            "uuid": "b89ecc19-1176-bc9f-fa20-0fe7004696ac",
            "name": "myCube",
            "type": "Mesh",//类型(Mesh：几何体；Model：模型)
            "geometry": "4c8a157e-cbfd-2897-26f7-8916b71fdd57",//几何体uuid
            "material": "d7b7980e-1eb3-7c73-4d00-78498e973e31",//材质
            "castShadow": true,//产生阴影否
            "receiveShadow": true//接受阴影否
        }
          {
            "uuid": "b89ecc19-1176-bc9f-fa20-0fe7004696ac",
            "name": "myCube",
            "type": "Model",//类型(Mesh：几何体；Model：模型)
            "url":"/assets/hammer.fbx" //模型地址 
            "material": "d7b7980e-1eb3-7c73-4d00-78498e973e31",//材质
            "castShadow": true,//产生阴影否
            "receiveShadow": true//接受阴影否
        }
    ]
```

### 几何体：

```shell
   "geometries": [
        {
            "uuid": "4c8a157e-cbfd-2897-26f7-8916b71fdd57",//uuid
            "name": "myCube",//名称
            "type": "BoxBufferGeometry",//类型
            "width": 5,
            "height": 5,
            "depth": 5
        }
    ],
```

### 材质：

```shell
"materials": [
		//颜色材质
        {
            "uuid": "d7b7980e-1eb3-7c73-4d00-78498e973e31",
            "name": "myMeshPhongMaterial",
            "type": "MeshPhongMaterial",
            "color": 65280
        }
        //纹理材质
        {
            "uuid": "13fbaf80-7196-f907-ccb3-618c2816beaf",
            "name": "groundMaterial",
            "type": "MeshLambertMaterial",
            "transparent": true,
            "opacity": 8, //透明度
            "color": 16777215,//颜色
            "map": "7d8a7dd9-392b-7dc0-4b62-a31e668c8875" // 纹理uuid
        }
    ],
```

### 纹理：

```shell
 "textures": [
        {
            "uuid": "fbaa60f3-4a20-4111-88c6-1e90a0e7e4fe",
            "name": "mySmokeparticle",
            "textureType": "Texture",
            "image": "6ea0af92-ed2e-55e8-9a96-1b44c8973583" //图片uuid
        }
    ],
```

### 图片、音频、视频：

```shell
"images": [
        {
            "uuid": "6ea0af92-ed2e-55e8-9a96-1b44c8973583",
            "name": "mySmokeparticle",
            "type": "image",
            "url": "/libs/assets/particle/smokeparticle.png"
        }
    ],
    "audios": [],
    "videos": [],
```

### 主题：

```shell
    "themes": [
        {
            "uuid": "5fc76181-553b-c49a-7315-23b2675ce58f",
            "name": "myTheme",
            "type": "theme",
            "skins": []
        }
    ]
```

### 粒子：

粒子里面包括多个分组，分组里面包括多个发射器。

```shell
 "particles": [
        {
            "uuid": "9b481b64-76fa-795d-4c36-344f3fa0eb8d",
            "name": "myParticleProject",
            "type": "particle",
            //分组
            "groups": [
                {
                    "uuid": "group0f3-4a20-4111-88c6-1e90a0e7e4fe",
                    "texture": {
                        "value": "fbaa60f3-4a20-4111-88c6-1e90a0e7e4fe"
                    },
                    "blending": 1,
                    "name": "myGroup",
                    //发射器
                    "emitters": [
                        {
                            "uuid": "emitter3-4a20-4111-88c6-1e90a0e7e4fe",
                            "name": "myEmitter",
                            "type": 1,
                            "particleCount": 2000,
                            "position": {
                                "value": {
                                    "x": 0,
                                    "y": -6,
                                    "z": 0
                                }
                            },
                            "velocity": {
                                "value": {
                                    "x": 0,
                                    "y": 25,
                                    "z": 0
                                },
                                "spread": {
                                    "x": 10,
                                    "y": 7.5,
                                    "z": 10
                                }
                            },
                            "acceleration": {
                                "value": {
                                    "x": 0,
                                    "y": -10,
                                    "z": 0
                                },
                                "spread": {
                                    "x": 10,
                                    "y": 0,
                                    "z": 10
                                }
                            },
                            "rotation": {
                                "axis": {
                                    "x": 1,
                                    "y": 10,
                                    "z": 1
                                }
                            },
                            "color": {
                                "value": [
                                    "#ffffff",
                                    "#ff0000"
                                ]
                            },
                            "size": {
                                "value": [
                                    "1"
                                ],
                                "randomise": true
                            }
                        }
                    ]
                }
            ]
        }
    ],
```

###  分组：

 资源组里面包含需要预加载的资源。

```shell
"groups": [
        {
            "uuid": "e8aa42e5-96ff-1907-83cd-78546d6fb260",
            "name": "分组1",
            "units": [],
            "gameobjects": [],
            "geometries": [],
            "textures": [],
            "materials": [],
            "audios": [],
            "images": [],
            "videos": [],
            "fonts": [],
            "particles": []
        }
    ],
```

### 舞台：

 舞台包括了摄像头、灯光、场景，物体，UI，插件等需要使用到舞台上的资源。在舞台中可以修改资源的属性。

```shell
"scenes": [
        {
            "uuid": "59C56073-3FC7-4934-BA95-B3C4BC6CB571",
            "name": "myScene1",
            "desc": "",
            //摄像头
            "camera": {
                "uuid": "9f69024a-6003-8735-3ca4-7b3166995727",
                "ouuid": "d4ed89cd-487a-de57-6909-f7bec6f677c3",
                "type": "PerspectiveCamera",
                "name": "myPerspectiveCamera",
                "position": {
                    "x": 0,
                    "y": 15,
                    "z": 35
                },
                "near": 0.01,
                "far": 1000
            },
            //灯光
            "lights": [
                {
                    "uuid": "a78e5fe7-ea0f-1319-4f18-647e27b8f712",
                    "type": "DirectionalLight",
                    "name": "directionalLight",
                    "color": 16777215,
                    "position": {
                        "x": 0,
                        "y": 5,
                        "z": 0
                    },
                    "castShadow": true,
                    "shadow": {
                        "camera": {
                            "uuid": "E4606B4A-18E2-49BF-B84E-3D7FD40F76B3",
                            "type": "OrthographicCamera",
                            "left": -15,
                            "right": 15,
                            "top": 15,
                            "bottom": -15,
                            "near": 1,
                            "far": 10,
                            "width": 1024,
                            "height": 1024
                        }
                    },
                    "target": {
                        "uuid": "066C7957-ACAB-43D5-9B83-FB126FD6EF23",
                        "type": "Object3D"
                    },
                    "light": "62e1092e-1b3b-9f6e-65f7-43c3c92b99e1"
                },
                {
                    "uuid": "beb0d179-3a17-ccd5-4c4c-7dd4e627b16c",
                    "type": "AmbientLight",
                    "name": "ambientLight",
                    "color": 16777215,
                    "light": "2c24963e-e270-4574-ca68-902a17167921"
                }
            ],
            //场景
            "scene": {
                "uuid": "345a57ab-9ed4-6c1c-dfeb-73e472a15896",
                "type": "Scene",
                "background": 2050429,
                "fog": {
                    "type": "Fog"
                }
            },
            //物体
            "children": [
                {
                    "uuid": "e53ce6a6-0437-2ca5-971a-d3fd92ac9732",
                    "name": "myPlane",
                    "type": "GameObject",
                    //单位
                    "unit": {
                        "uuid": "960266f6-d848-daae-e1de-d713007a4f5c",
                        "name": "myPlane",
                        "type": "Mesh",
                        //几何体
                        "geometry": {
                            "uuid": "69cc1f3c-57a8-bee3-3e9c-db49928b40a6",
                            "name": "myPlane",
                            "type": "PlaneBufferGeometry",
                            "width": 10,
                            "height": 10,
                            "ouuid": "d09168dc-f4d6-baa3-94e2-a37b013ce9f5"
                        },
                        "ouuid": "99f2089d-e946-764f-9cc3-34ac8fb1237e",
                        "rotation": {
                            "x": 1.57,
                            "y": 0,
                            "z": 0
                        },
                        "castShadow": true,
                        "receiveShadow": true
                    },
                    "gameobject": "389c90f9-67c6-ac73-5147-cb80f99b8b6e"
                },
                {
                    "uuid": "f5d49676-13b5-acf0-bec0-35a614551c8e",
                    "name": "myCube",
                    "unit": {
                        "uuid": "6a8f8115-3dc8-38ca-76ec-40ba47a6df13",
                        "name": "cube",
                        "type": "Mesh",
                        "geometry": {
                            "uuid": "1639f2a5-698b-0e2c-b875-1c1dc7c90bf2",
                            "name": "cube",
                            "type": "BoxBufferGeometry",
                            "width": 5,
                            "height": 5,
                            "depth": 5,
                            "ouuid": "4c8a157e-cbfd-2897-26f7-8916b71fdd57"
                        },
                        "castShadow": true,
                        "receiveShadow": true,
                        "ouuid": "b89ecc19-1176-bc9f-fa20-0fe7004696ac",
                        "position": {
                            "x": 0,
                            "y": 5,
                            "z": 0
                        }
                    },
                    "type": "GameObject",
                    "gameobject": "53f8c942-408c-b041-1c97-b5cfa3e03e33"
                }
            ],
            //UI
            "uiChildren": [],
            //插件
            "plugins": [
                {
                    "uuid": "e208c8d6-cf93-6d36-ce1e-8dca158ace77",
                    "varName": "terrian",
                    "name": "地形生成器",
                    "type": "object",
                    "src": "terrian/Terrian.js",
                    "config": {
                        "width": 100,
                        "height": 100,
                        "widthSegments": 3,
                        "heightSegments": 4,
                        "maxHeight": 100,
                        "minHeight": 0,
                        "texture": "/libs/assets/qrcode.jpg",
                        "vertexHeights": [...]
                    }
                },
                {
                    "uuid": "e72a6a67-ba76-0955-34f1-4d43b0dbcb86",
                    "varName": "skybox",
                    "name": "天空盒",
                    "type": "object",
                    "src": "skybox/skybox.js",
                    "config": {
                        "width": 1024,
                        "height": 1024,
                        "depth": 1024,
                        "geometryType": "cube",
                        "images": [
                            "/libs/plugins/skybox/px.jpg",...
                        ]
                    },
                    "editor": "skybox"
                }
            ],
            //辅助
            "helpers": []
        }
    ],
```

