# 文档写作规范

写作基本规范：

- 简明扼要，不要任何一句废话
- 对特殊逻辑和注意点要说清楚
- 稍有难以理解的要有示例
- 属性、方法和事件中的例子 “就事论事”，最后的例子可以稍微综合点
- 可以链接到别的文档的，做好链接，以相对路径方式
- 所有图片都采用 .jpg 格式，并放置在 `docs/imgs` 路径下
- 多行代码做好格式排版，文字中的单行代码也要标好
- 虽然用 jsdoc 很快，但考虑到灵活性和升级的频繁性，还是手写文档
- 表格不要用图片代替
- 层级最大为三级

## 构成

基本、属性、方法、事件、示例。

基本中叙述：

- 基本概念和功能
- 继承于

属性中叙述：

- **属性名** : 类型，属性名加粗
- 属性含义
- 只读和默认，不是只读不用标注
- 可选值及其含义
- 示例，可选
- 注意冒号两端有空格，且名称加粗

方法中叙述：

- **方法名**(参数 : 类型) : 返回类型，无返回写做 void，方法名加粗
- 方法含义
- 示例，可选

事件中叙述：

- **事件名**(参数 : 类型)，事件名加粗
- 参数格式
- 事件含义
- 示例，可选
- 无事件可以写做：无

示例中叙述：

- 无示例可以写做：无